set HomeDir [file normalize [file dirname [info script]]]
package require Tk
#catch {console show}

package require tkribbon

## Toplevel: . (using grid)
grid [tkribbon::ribbon .ribbon] -sticky snew
grid [ttk::button .exit -command exit -text Exit] -sticky snew
## It is important that the ribbon widget covers the whole width of the
## topelevel, else the title bar will not be drawn!
grid columnconfigure . 0 -weight 1
grid rowconfigure    . 1 -weight 1

## Toplevel: .x (using pack)
toplevel .x
pack [tkribbon::ribbon .x.ribbon] -fill x -side top
pack [ttk::button .x.exit -command exit -text Exit] -fill both -expand true

## Use any ribbon widget, to load a dll that contains ribbons.
## In essense, load_resources just calls LoadLibrary!
## This means than resources in Tcl extensions can also be used, loaded with
## load...
.ribbon   load_resources [file nativename $HomeDir/Ribbon.dll]

## Load a ribbon UI. We need to specify the module (dll) and the ribbon name.
.ribbon   load_ui Ribbon.dll         APPLICATION_RIBBON
.x.ribbon load_ui libtkribbon1.0.dll APPLICATION_RIBBON

wm geometry . 800x250
wm geometry .x 600x250

## Handle events...
bind .ribbon   <<onExecute>> [list puts "Button Clicked: %d"]
bind .x.ribbon <<onExecute>> [list puts "Button Clicked: %d"]
